const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const frames_imagem = sequelize.define(
    'frames_imagem',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      origem: {
        type: DataTypes.ENUM,

        values: ['drone', 'ptz'],
      },

      imagem_url: {
        type: DataTypes.TEXT,
      },

      timestamp_frame: {
        type: DataTypes.DATE,
      },

      observacoes: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  frames_imagem.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.frames_imagem.hasMany(db.pessoas_frame, {
      as: 'pessoas_frame_frame',
      foreignKey: {
        name: 'frameId',
      },
      constraints: false,
    });

    //end loop

    db.frames_imagem.belongsTo(db.inspecao_aerea, {
      as: 'inspecao',
      foreignKey: {
        name: 'inspecaoId',
      },
      constraints: false,
    });

    db.frames_imagem.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.frames_imagem.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.frames_imagem.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return frames_imagem;
};
